//+------------------------------------------------------------------+
//|                                          True_Fractals_Level.mq4 |
//|                                                      TO StatBars |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 OrangeRed

extern string TimeFrame         = "Current time frame";   
extern int    Level             = 5;
extern bool   FractalOnFirstBar = true;

double Upper[];
double Lower[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,Upper); SetIndexStyle( 0, DRAW_ARROW); SetIndexArrow( 0, 217) ;
   SetIndexBuffer(1,Lower); SetIndexStyle( 1, DRAW_ARROW); SetIndexArrow( 1, 218) ;
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,Level/2+1),Bars-1);
           if (returnBars) { Upper[0] = limit+1; return(0); }
           if (timeFrame!=Period())
           {
               int shift = -1; if (FractalOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);   
                  int x = iBarShift(NULL,timeFrame,Time[i+shift]);               
                  if (x!=y)
                  {
                     Upper[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Level,0,y);
                     Lower[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Level,1,y);
                  }
               }
               return(0);
           }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      Upper[i] = EMPTY_VALUE;
      Lower[i] = EMPTY_VALUE;
      if( iHighest( Symbol(),0, MODE_HIGH, Level, i-Level/2) == i) Upper[i] = High[i];
      if( iLowest ( Symbol(),0, MODE_LOW,  Level, i-Level/2) == i) Lower[i] = Low[i];
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
  StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}